Index: component-matrix/pom.xml
===================================================================
--- component-matrix/pom.xml	(revision 111100)
+++ component-matrix/pom.xml	(working copy)
@@ -43,7 +43,7 @@
     <version.commons.beanutils>1.8.0</version.commons.beanutils>
     <version.com.google.guava>r06</version.com.google.guava>
     <version.fastinfoset>1.2.2</version.fastinfoset>
-    <version.hornetq>2.1.2.Final</version.hornetq>
+    <version.hornetq>2.2.2.Final</version.hornetq>
     <version.rhq>1.4.0.B01</version.rhq>
     <version.jacorb>2.3.1jboss.patch01-brew</version.jacorb>
     <version.javassist>3.12.1.GA</version.javassist>
Index: hornetq-int/src/main/java/org/jboss/as/integration/hornetq/management/jms/TopicManageMO.java
===================================================================
--- hornetq-int/src/main/java/org/jboss/as/integration/hornetq/management/jms/TopicManageMO.java	(revision 111100)
+++ hornetq-int/src/main/java/org/jboss/as/integration/hornetq/management/jms/TopicManageMO.java	(working copy)
@@ -82,6 +82,7 @@
            @ManagementParameter(name = "expiryAddress", description = "Expiry Address"),
            @ManagementParameter(name = "maxSizeBytes", description = "Max Size of Address"),
            @ManagementParameter(name = "pageSizeBytes", description = "Page Size"),
+	   @ManagementParameter(name = "pageMaxCacheSize", description = "Page Max Cache Size"),
            @ManagementParameter(name = "deliveryAttempts", description = "Max Delivery Attempts"),
            @ManagementParameter(name = "redeliveryDelay", description = "Redelivery Delay"),
            @ManagementParameter(name = "lastValueQueue", description = "Last Value Queue"),
@@ -101,6 +102,7 @@
                            String expiryAddress,
                            long maxSizeBytes,
                            int pageSizeBytes,
+                           int pageMaxCacheSize,
                            int deliveryAttempts,
                            long redeliveryDelay,
                            boolean lastValueQueue,
@@ -123,6 +125,7 @@
           deliveryAttempts,
           maxSizeBytes,
           pageSizeBytes,
+	  pageMaxCacheSize,
           redeliveryDelay,
           redistributionDelay,
           sendToDLAOnNoRoute,
@@ -141,6 +144,7 @@
            @ManagementParameter(name = "expiryAddress", description = "Expiry Address"),
            @ManagementParameter(name = "maxSizeBytes", description = "Max Size of Address"),
            @ManagementParameter(name = "pageSizeBytes", description = "Page Size"),
+	   @ManagementParameter(name = "pageMaxCacheSize", description = "Page Max Cache Size"),
            @ManagementParameter(name = "deliveryAttempts", description = "Max Delivery Attempts"),
            @ManagementParameter(name = "redeliveryDelay", description = "Redelivery Delay"),
            @ManagementParameter(name = "lastValueQueue", description = "Last Value Queue"),
@@ -160,6 +164,7 @@
                                         String expiryAddress,
                                         long maxSizeBytes,
                                         int pageSizeBytes,
+				        int pageMaxCacheSize,
                                         int deliveryAttempts,
                                         long redeliveryDelay,
                                         boolean lastValueQueue,
@@ -181,6 +186,7 @@
           deliveryAttempts,
           maxSizeBytes,
           pageSizeBytes,
+	  pageMaxCacheSize,
           redeliveryDelay,
           redistributionDelay,
           sendToDLAOnNoRoute,
Index: hornetq-int/src/main/java/org/jboss/as/integration/hornetq/management/jms/QueueManageMO.java
===================================================================
--- hornetq-int/src/main/java/org/jboss/as/integration/hornetq/management/jms/QueueManageMO.java	(revision 111100)
+++ hornetq-int/src/main/java/org/jboss/as/integration/hornetq/management/jms/QueueManageMO.java	(working copy)
@@ -56,6 +56,7 @@
            @ManagementParameter(name = "expiryAddress", description = "Expiry Address"),
            @ManagementParameter(name = "maxSizeBytes", description = "Max Size of Address"),
            @ManagementParameter(name = "pageSizeBytes", description = "Page Size"),
+           @ManagementParameter(name = "pageMaxCacheSize", description = "Page Max Cache Size"),
            @ManagementParameter(name = "deliveryAttempts", description = "Max Delivery Attempts"),
            @ManagementParameter(name = "redeliveryDelay", description = "Redelivery Delay"),
            @ManagementParameter(name = "lastValueQueue", description = "Last Value Queue"),
@@ -71,6 +72,7 @@
                            String expiryAddress,
                            long maxSizeBytes,
                            int pageSizeBytes,
+                           int pageMaxCacheSize,
                            int deliveryAttempts,
                            long redeliveryDelay,
                            boolean lastValueQueue,
@@ -80,8 +82,6 @@
                            String sendRoles,
                            String consumeRoles) throws Exception
    {
-
-      //update the address settings
       hornetQServerControl.addAddressSettings("jms.queue." + name,
           DLA,
           expiryAddress,
@@ -89,6 +89,7 @@
           deliveryAttempts,
           maxSizeBytes,
           pageSizeBytes,
+          pageMaxCacheSize,
           redeliveryDelay,
           redistributionDelay,
           sendToDLAOnNoRoute,
@@ -133,6 +134,7 @@
            @ManagementParameter(name = "expiryAddress", description = "Expiry Address"),
            @ManagementParameter(name = "maxSizeBytes", description = "Max Size of Address"),
            @ManagementParameter(name = "pageSizeBytes", description = "Page Size"),
+           @ManagementParameter(name = "pageMaxCacheSize", description = "Page Max Cache Size"),
            @ManagementParameter(name = "deliveryAttempts", description = "Max Delivery Attempts"),
            @ManagementParameter(name = "redeliveryDelay", description = "Redelivery Delay"),
            @ManagementParameter(name = "lastValueQueue", description = "Last Value Queue"),
@@ -148,6 +150,7 @@
                                         String expiryAddress,
                                         long maxSizeBytes,
                                         int pageSizeBytes,
+                                        int pageMaxCacheSize,
                                         int deliveryAttempts,
                                         long redeliveryDelay,
                                         boolean lastValueQueue,
@@ -165,6 +168,7 @@
           deliveryAttempts,
           maxSizeBytes,
           pageSizeBytes,
+          pageMaxCacheSize,
           redeliveryDelay,
           redistributionDelay,
           sendToDLAOnNoRoute,
Index: hornetq-int/src/main/java/org/jboss/as/integration/hornetq/management/jms/ConnectionFactoryManageMO.java
===================================================================
--- hornetq-int/src/main/java/org/jboss/as/integration/hornetq/management/jms/ConnectionFactoryManageMO.java	(revision 111100)
+++ hornetq-int/src/main/java/org/jboss/as/integration/hornetq/management/jms/ConnectionFactoryManageMO.java	(working copy)
@@ -103,14 +103,14 @@
    @ManagementOperation(name = "createConnectionFactory", description = "creates a connection factories",
        params = {
            @ManagementParameter(name = "name", description = "the connection factory name"),
-           @ManagementParameter(name = "liveTransportClassNames", description = "comma-separated list of class names for transport to live servers"),
-           @ManagementParameter(name = "liveTransportParams", description = "comma-separated list of key=value parameters for the live transports (enclosed between { } for each transport)"),
-           @ManagementParameter(name = "backupTransportClassNames", description = "comma-separated list of class names for transport to backup servers"),
-           @ManagementParameter(name = "backupTransportParams", description = "comma-separated list of key=value parameters for the backup transports (enclosed between { } for each transport)"),
+           @ManagementParameter(name = "ha", description = "true if HA"),
+           @ManagementParameter(name = "useDiscovery", description = "true if use discovery"),
+	   // @Parameter(name = "cfType", desc = "RegularCF=0, QueueCF=1, TopicCF=2, XACF=3, QueueXACF=4, TopicXACF=5") int cfType,
+           @ManagementParameter(name = "cfType", description = "RegularCF=0, QueueCF=1, TopicCF=2, XACF=3, QueueXACF=4, TopicXACF=5"),
+           @ManagementParameter(name = "connectorNames", description = "comma-separated list of connectorNames or the discovery group name"),
            @ManagementParameter(name = "bindings", description = "comma-separated list of JNDI bindings"),
            @ManagementParameter(name = "discoveryAddress", description = "a discovery address"),
            @ManagementParameter(name = "discoveryPort", description = "a discovery port"),
-           @ManagementParameter(name = "discoveryRefreshTimeout", description = "the discovery refresh timeout"),
            @ManagementParameter(name = "clientId", description = "the client id"),
            @ManagementParameter(name = "dupsOkBatchSize", description = "the batch size for DUPS_OK acknowledge mode"),
            @ManagementParameter(name = "transactionBatchSize", description = "the transaction batch size"),
@@ -131,23 +131,21 @@
            @ManagementParameter(name = "maxRetryInterval", description = "the max retry interval"),
            @ManagementParameter(name = "retryIntervalMultiplier", description = "the max retry interval multiplier"),
            @ManagementParameter(name = "reconnectAttempts", description = "the reconnect attempts"),
-           @ManagementParameter(name = "failoverOnShutdown", description = "do we failover on a clean shutdown"),
+           @ManagementParameter(name = "failoverOnInitialConnection", description = "do we failover on a clean shutdown"),
            @ManagementParameter(name = "scheduledThreadPoolMaxSize", description = "the pool size for scheduled threads"),
            @ManagementParameter(name = "threadPoolMaxSize", description = "the pool size for threads"),
            @ManagementParameter(name = "groupId", description = "the group id"),
-           @ManagementParameter(name = "initialMessagePacketSize", description = "the initial message packet size"),
            @ManagementParameter(name = "useGlobalPools", description = "do we use global pools"),
            @ManagementParameter(name = "retryInterval", description = "the retry interval"),
            @ManagementParameter(name = "connectionLoadBalancingPolicyClassName", description = "the load balancing class")})
    public void createConnectionFactory(String name,
-                                        final String liveTransportClassNames,
-                                        final String liveTransportParams,
-                                        final String backupTransportClassNames,
-                                        final String backupTransportParams, 
+                                        final boolean ha,
+                                        final boolean useDiscovery,
+                                        final int cfType,
+                                        final String connectorNames, 
                                         String bindings,
                                         String discoveryAddress,
                                         int discoveryPort,
-                                        long discoveryRefreshTimeout,
                                         String clientId,
                                         int dupsOkBatchSize,
                                         int transactionBatchSize,
@@ -168,27 +166,30 @@
                                         long maxRetryInterval,
                                         double retryIntervalMultiplier,
                                         int reconnectAttempts,
-                                        boolean failoverOnShutdown,
+                                        boolean failoverOnInitialConnection,
                                         int scheduledThreadPoolMaxSize,
                                         int threadPoolMaxSize,
                                         String groupId,
-                                        int initialMessagePacketSize,
                                         boolean useGlobalPools,
                                         long retryInterval,
                                         String connectionLoadBalancingPolicyClassName)
          throws Exception
    {
+      /* TODO HornetQ 2.1.2 old config
       if(liveTransportClassNames != null)
       {
          jmsServerControl.createConnectionFactory(name, liveTransportClassNames, liveTransportParams == null?"":liveTransportParams,
                backupTransportClassNames == null?"":backupTransportClassNames, backupTransportParams == null?"":backupTransportParams, bindings);
+         jmsServerControl.createConnectionFactory(name, discoveryAddress, discoveryPort, bindings);
       }
       else
       {
          jmsServerControl.createConnectionFactory(name, discoveryAddress, discoveryPort, bindings);
       }
+      */
+      jmsServerControl.createConnectionFactory(name, ha, useDiscovery, cfType, connectorNames, bindings);
+
       ConnectionFactoryControl control = (ConnectionFactoryControl) managementService.getResource("jms.connectionfactory." + name);
-      control.setDiscoveryRefreshTimeout(discoveryRefreshTimeout);
       control.setClientID(clientId);
       control.setDupsOKBatchSize(dupsOkBatchSize);
       control.setTransactionBatchSize(transactionBatchSize);
@@ -209,11 +210,10 @@
       control.setMaxRetryInterval(maxRetryInterval);
       control.setRetryIntervalMultiplier(retryIntervalMultiplier);
       control.setReconnectAttempts(reconnectAttempts);
-      control.setFailoverOnServerShutdown(failoverOnShutdown);
+      control.setFailoverOnInitialConnection(failoverOnInitialConnection);
       control.setScheduledThreadPoolMaxSize(scheduledThreadPoolMaxSize);
       control.setThreadPoolMaxSize(threadPoolMaxSize);
       control.setGroupID(groupId);
-      control.setInitialMessagePacketSize(initialMessagePacketSize);
       control.setUseGlobalPools(useGlobalPools);
       control.setRetryInterval(retryInterval);
       control.setConnectionLoadBalancingPolicyClassName(connectionLoadBalancingPolicyClassName);
@@ -222,7 +222,6 @@
    @ManagementOperation(name = "createConnectionFactory", description = "creates a connection factories",
        params = {
            @ManagementParameter(name = "name", description = "the connection factory name"),
-           @ManagementParameter(name = "discoveryRefreshTimeout", description = "the discovery refresh timeout"),
            @ManagementParameter(name = "clientId", description = "the client id"),
            @ManagementParameter(name = "dupsOkBatchSize", description = "the batch size for DUPS_OK acknowledge mode"),
            @ManagementParameter(name = "transactionBatchSize", description = "the transaction batch size"),
@@ -243,16 +242,14 @@
            @ManagementParameter(name = "maxRetryInterval", description = "the max retry interval"),
            @ManagementParameter(name = "retryIntervalMultiplier", description = "the max retry interval multiplier"),
            @ManagementParameter(name = "reconnectAttempts", description = "the reconnect attempts"),
-           @ManagementParameter(name = "failoverOnShutdown", description = "do we failover on a clean shutdown"),
+           @ManagementParameter(name = "failoverOnInitialConnection", description = "do we failover on a clean shutdown"),
            @ManagementParameter(name = "scheduledThreadPoolMaxSize", description = "the pool size for scheduled threads"),
            @ManagementParameter(name = "threadPoolMaxSize", description = "the pool size for threads"),
            @ManagementParameter(name = "groupId", description = "the group id"),
-           @ManagementParameter(name = "initialMessagePacketSize", description = "the initial message packet size"),
            @ManagementParameter(name = "useGlobalPools", description = "do we use global pools"),
            @ManagementParameter(name = "retryInterval", description = "the retry interval"),
            @ManagementParameter(name = "connectionLoadBalancingPolicyClassName", description = "the load balancing class")})
    public void updateConnectionFactory(String name,
-                                        long discoveryRefreshTimeout,
                                         String clientId,
                                         int dupsOkBatchSize,
                                         int transactionBatchSize,
@@ -273,18 +270,16 @@
                                         long maxRetryInterval,
                                         double retryIntervalMultiplier,
                                         int reconnectAttempts,
-                                        boolean failoverOnShutdown,
+                                        boolean failoverOnInitialConnection,
                                         int scheduledThreadPoolMaxSize,
                                         int threadPoolMaxSize,
                                         String groupId,
-                                        int initialMessagePacketSize,
                                         boolean useGlobalPools,
                                         long retryInterval,
                                         String connectionLoadBalancingPolicyClassName)
          throws Exception
    {
       ConnectionFactoryControl control = (ConnectionFactoryControl) managementService.getResource("jms.connectionfactory." + name);
-      control.setDiscoveryRefreshTimeout(discoveryRefreshTimeout);
       control.setClientID(clientId);
       control.setDupsOKBatchSize(dupsOkBatchSize);
       control.setTransactionBatchSize(transactionBatchSize);
@@ -305,11 +300,10 @@
       control.setMaxRetryInterval(maxRetryInterval);
       control.setRetryIntervalMultiplier(retryIntervalMultiplier);
       control.setReconnectAttempts(reconnectAttempts);
-      control.setFailoverOnServerShutdown(failoverOnShutdown);
+      control.setFailoverOnInitialConnection(failoverOnInitialConnection);
       control.setScheduledThreadPoolMaxSize(scheduledThreadPoolMaxSize);
       control.setThreadPoolMaxSize(threadPoolMaxSize);
       control.setGroupID(groupId);
-      control.setInitialMessagePacketSize(initialMessagePacketSize);
       control.setUseGlobalPools(useGlobalPools);
       control.setRetryInterval(retryInterval);
       control.setConnectionLoadBalancingPolicyClassName(connectionLoadBalancingPolicyClassName);
Index: hornetq-int/src/main/java/org/jboss/as/integration/hornetq/management/jms/ConnectionFactoryMapper.java
===================================================================
--- hornetq-int/src/main/java/org/jboss/as/integration/hornetq/management/jms/ConnectionFactoryMapper.java	(revision 111100)
+++ hornetq-int/src/main/java/org/jboss/as/integration/hornetq/management/jms/ConnectionFactoryMapper.java	(working copy)
@@ -21,8 +21,8 @@
  */
 package org.jboss.as.integration.hornetq.management.jms;
 
-import org.hornetq.api.core.Pair;
 import org.hornetq.api.core.TransportConfiguration;
+import org.hornetq.api.core.DiscoveryGroupConfiguration;
 import org.hornetq.api.jms.management.ConnectionFactoryControl;
 import org.jboss.metatype.api.types.CompositeMetaType;
 import org.jboss.metatype.api.types.ImmutableCompositeMetaType;
@@ -78,7 +78,7 @@
             "MaxRetryInterval",
             "RetryIntervalMultiplier",
             "ReconnectAttempts",
-            "FailoverOnServerShutdown",
+            "FailoverOnInitialConnection",
             "ScheduledThreadPoolMaxSize",
             "ThreadPoolMaxSize",
             "GroupID",
@@ -119,7 +119,7 @@
             "MaxRetryInterval",
             "RetryIntervalMultiplier",
             "ReconnectAttempts",
-            "FailoverOnServerShutdown",
+            "FailoverOnInitialConnection",
             "ScheduledThreadPoolMaxSize",
             "ThreadPoolMaxSize",
             "GroupID",
@@ -178,67 +178,41 @@
    {
       CompositeValueSupport cvs = new CompositeValueSupport(TYPE);
       cvs.set("name", new SimpleValueSupport(SimpleMetaType.STRING, control.getName()));
-      List<org.hornetq.api.core.Pair<TransportConfiguration, TransportConfiguration>> pairs = control.getStaticConnectors();
+      TransportConfiguration configs[] = control.getStaticConnectors();
       StringBuffer liveTransportClassNames = new StringBuffer();
       StringBuffer liveTransportParams = new StringBuffer();
       StringBuffer backupTransportClassNames = new StringBuffer();
       StringBuffer backupTransportParams = new StringBuffer();
-      for (Pair<TransportConfiguration, TransportConfiguration> pair : pairs)
+      for (TransportConfiguration tc : configs)
       {
-         if (pair.a != null)
-         {
-            TransportConfiguration live = pair.a;
-            if(liveTransportClassNames.length() > 0)
-            {
-               liveTransportClassNames.append(",");
-            }
-            liveTransportClassNames.append(live.getFactoryClassName());
+	 if(liveTransportClassNames.length() > 0)
+	 {
+	    liveTransportClassNames.append(",");
+	 }
+	 liveTransportClassNames.append(tc.getFactoryClassName());
 
-            Map<String, Object> params = live.getParams();
-            liveTransportParams.append("{");
-            for (Map.Entry<String, Object> stringObjectEntry : params.entrySet())
-            {
-               if(liveTransportParams.length() > 1)
-               {
-                  liveTransportParams.append(",");
-               }
-               liveTransportParams.append(stringObjectEntry.getKey()).append("=").append(stringObjectEntry.getValue());
-            }
-            liveTransportParams.append("}");
-         }
-
-         if (pair.b != null)
-         {
-            TransportConfiguration backUp = pair.b;
-            if(backupTransportClassNames.length() > 0)
-            {
-               backupTransportClassNames.append(",");
-            }
-            backupTransportClassNames.append(backUp.getFactoryClassName());
-
-            Map<String, Object> params = backUp.getParams();
-            backupTransportParams.append("{");
-            for (Map.Entry<String, Object> stringObjectEntry : params.entrySet())
-            {
-               if(backupTransportParams.length() > 1)
-               {
-                  backupTransportParams.append(",");
-               }
-               backupTransportParams.append(stringObjectEntry.getKey()).append("=").append(stringObjectEntry.getValue());
-            }
-            backupTransportParams.append("}");
-         }
-
+	 Map<String, Object> params = tc.getParams();
+	 liveTransportParams.append("{");
+	 for (Map.Entry<String, Object> stringObjectEntry : params.entrySet())
+	 {
+	    if(liveTransportParams.length() > 1)
+	    {
+	       liveTransportParams.append(",");
+	    }
+	    liveTransportParams.append(stringObjectEntry.getKey()).append("=").append(stringObjectEntry.getValue());
+	 }
+	 liveTransportParams.append("}");
       }
       cvs.set("liveTransportClassNames", new SimpleValueSupport(SimpleMetaType.STRING, liveTransportClassNames));
       cvs.set("liveTransportParams", new SimpleValueSupport(SimpleMetaType.STRING, liveTransportParams));
       cvs.set("backupTransportClassNames", new SimpleValueSupport(SimpleMetaType.STRING, backupTransportClassNames));
       cvs.set("backupTransportParams", new SimpleValueSupport(SimpleMetaType.STRING, backupTransportParams));
       cvs.set("Bindings", new SimpleValueSupport(SimpleMetaType.STRING, getJndiString(control.getJNDIBindings())));
-      cvs.set("DiscoveryAddress", new SimpleValueSupport(SimpleMetaType.STRING, control.getDiscoveryAddress()));
-      cvs.set("DiscoveryPort", new SimpleValueSupport(SimpleMetaType.STRING, control.getDiscoveryPort()));
-      cvs.set("DiscoveryRefreshTimeout", new SimpleValueSupport(SimpleMetaType.STRING, control.getDiscoveryRefreshTimeout()));
-      cvs.set("DiscoveryInitialWaitTimeout", new SimpleValueSupport(SimpleMetaType.STRING, control.getDiscoveryInitialWaitTimeout()));
+      DiscoveryGroupConfiguration dgc = control.getDiscoveryGroupConfiguration();
+      cvs.set("DiscoveryAddress", new SimpleValueSupport(SimpleMetaType.STRING, dgc.getGroupAddress()));
+      cvs.set("DiscoveryPort", new SimpleValueSupport(SimpleMetaType.STRING, dgc.getGroupPort()));
+      cvs.set("DiscoveryRefreshTimeout", new SimpleValueSupport(SimpleMetaType.STRING, dgc.getRefreshTimeout()));
+      cvs.set("DiscoveryInitialWaitTimeout", new SimpleValueSupport(SimpleMetaType.STRING, dgc.getDiscoveryInitialWaitTimeout()));
       cvs.set("ClientID", new SimpleValueSupport(SimpleMetaType.STRING, control.getClientID()));
       cvs.set("DupsOKBatchSize", new SimpleValueSupport(SimpleMetaType.STRING, control.getDupsOKBatchSize()));
       cvs.set("TransactionBatchSize", new SimpleValueSupport(SimpleMetaType.STRING, control.getTransactionBatchSize()));
@@ -260,7 +234,7 @@
       cvs.set("MaxRetryInterval", new SimpleValueSupport(SimpleMetaType.STRING, control.getMaxRetryInterval()));
       cvs.set("RetryIntervalMultiplier", new SimpleValueSupport(SimpleMetaType.STRING, control.getRetryIntervalMultiplier()));
       cvs.set("ReconnectAttempts", new SimpleValueSupport(SimpleMetaType.STRING, control.getReconnectAttempts()));
-      cvs.set("FailoverOnServerShutdown", new SimpleValueSupport(SimpleMetaType.STRING, control.isFailoverOnServerShutdown()));
+      cvs.set("FailoverOnInitialConnection", new SimpleValueSupport(SimpleMetaType.STRING, control.isFailoverOnInitialConnection()));
       cvs.set("ScheduledThreadPoolMaxSize", new SimpleValueSupport(SimpleMetaType.STRING, control.getScheduledThreadPoolMaxSize()));
       cvs.set("ThreadPoolMaxSize", new SimpleValueSupport(SimpleMetaType.STRING, control.getThreadPoolMaxSize()));
       cvs.set("GroupID", new SimpleValueSupport(SimpleMetaType.STRING, control.getGroupID()));
Index: hornetq-int/src/main/java/org/jboss/as/integration/hornetq/management/template/JAXBJMSConfiguration.java
===================================================================
--- hornetq-int/src/main/java/org/jboss/as/integration/hornetq/management/template/JAXBJMSConfiguration.java	(revision 111100)
+++ hornetq-int/src/main/java/org/jboss/as/integration/hornetq/management/template/JAXBJMSConfiguration.java	(working copy)
@@ -89,4 +89,11 @@
    {
       this.topics = topics;
    }
+
+   public String getDomain()
+   {
+      // TODO Auto-generated method stub
+      return null;
+   }
+
 }